#include "json.hpp"

using namespace Etheryo;

JsonHandler::JsonHandler()
    : _dataBuffer({})
    , _buffer({})
{
}

void JsonHandler::clear()
{
    _buffer.clear();
}

void JsonHandler::add(const std::vector<std::string>& names)
{
    for (const auto& n : names)
        _dataBuffer.emplace(n, "");
}

std::string& JsonHandler::operator[](const std::string& rvalue)
{
    return _dataBuffer[rvalue];
}

void JsonHandler::push()
{
    _buffer.emplace_back(_dataBuffer);
}

std::string JsonHandler::to_str()
{
    std::string str = "[";
    size_t map_size(0), map_index(0), vec_index(0);

    for (const auto& map_data : _buffer) {
        vec_index++;
        str.push_back('{');
        map_size = map_data.size();
        for (auto it = map_data.begin(); it != map_data.end(); it++) {
            map_index++;
            str += ("\"" + it->first + "\": \"" + it->second + (map_index >= map_size ? "\"" : "\","));
        }
        map_index = 0;
        str.push_back('}');
        if (vec_index < _buffer.size())
            str.push_back(',');
    }
    str.push_back(']');
    return str;
}